#!/usr/bin/perl
#
#  Script to clean up /LOG directory to prevent loss of data due to a disk
#  partition filling up. This script will be run by fetchem nightly.
#  
#  Written by Bill Ralph 2/24/98
#  Re-written by Bill Ralph in Perl 3/12/98
#
# Set up some variables.
#
$ENV{PATH} = "/bin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/logger";
$today=`date +%h%d --date "15 min ago"`;
$clean_date=`date +%y%m%d -d "3 days 15 min ago"`;
chomp($clean_date);
$logger_name="firewall";
$sense_dir="/LOG";
#
#  Rid ourselves of standard output and error to prevent tons of mail messages
#  from cron.
#
if ( not $debug )
{
   open(STDOUT, ">>/tmp/cleanup.log");
   open(STDERR, ">&STDOUT");
   select STDERR; $| = 1;              # make unbuffered
   select STDOUT; $| = 1;              # make unbuffered
}
#
# Writer a marker to the log file.
#
$date=`date`;
chomp $date;
print STDOUT $date;
foreach $param ($0, @ARGV) {
   printf " %s", $param;
}
print STDOUT "\n";
#
sub usage {
        print "Usage: cleanup [-debug] -d CLEAN_DATE -n LOGGER_NAME.\n";
        exit 2;
}
#
#	Parse the parameters.
#
use Getopt::Long;
&GetOptions("debug", \$debug, "d:s", \$clean_date, "n:s", \$logger_name);
##
if ( $debug )
{
   print "d = $clean_date \n";
   print "n = $logger_name \n";
}
#
#  No need to check parameter validity. Unspecified parameters assume their
#  default values: $clean_date = 4 days ago; $logger_name = firewall.
#
#
#
# Remove the files matching our CLEAN_DATE
#
$file_pat="tcp.$clean_date??.gz";
$cmd="df $sense_dir;rm $sense_dir/$file_pat;df $sense_dir";
$cmd='"' . $cmd . '"';
if ( $debug )
{
   print STDOUT "Removing $sense_dir/$file_pat from $logger_name.\n";
   print STDOUT ("ssh -l root $logger_name $cmd\n");
} else {
   print STDOUT ("ssh -l root $logger_name $cmd\n");
   system ("ssh -l root $logger_name $cmd");
}
#
