#!/usr/bin/perl
#
# Read a tcpdump file and translate it so the SHADOW analysis engines can
# read it.
#
# Written by Bill Ralph - 3/19/98
#
# Set up some variables.
#
use Getopt::Long;
use Shell qw(gunzip tcpdump);
#
$ENV{PATH} = "/bin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/logger";
$logger_location="NSWC";

#
sub usage {
        print "Usage: translate2 -debug -d SNIFDATE -l LOGGER_LOCATION.\n";
        exit 2;
}
#
#       Parse the parameters.
#
#
&GetOptions("debug", \$debug, "d=s", \$snifdate, "l:s", \$logger_location);
##
#
#  Rid ourselves of standard output and error to prevent tons of mail messages
#  from cron.
#
#if ( not $debug )
#{
   open(LOGFILE, ">>/tmp/translate.log");
   select LOGFILE; $| = 1;
#   open(STDERR, ">&STDOUT");
#   select STDERR; $| = 1;              # make unbuffered
#   select STDOUT; $| = 1;              # make unbuffered
#}
#
# Writer a marker to the log file.
#
$date=`date`;
chomp $date;
print LOGFILE $date;
foreach $param ($0, @ARGV) {
   printf " %s", $param;
}
print LOGFILE "\n";
#
#
# Using the calling date parameter, reset the $subdir variable.
#
$date_len= length($snifdate);
if ($date_len == 8) {
   $sn1 = substr($snifdate,0,-2);
} else {
   $sn1 = $snifdate;
}
$subdir=`date -d $sn1 +%h%d`;
chomp($subdir);
$outdate=`date -d $sn1 +%D`;
chomp($outdate);
print LOGFILE "subdir = $subdir\n";

$newdata_machine="lotus:";
#
#  Define a hash variable to hold the actual tcpdump filters for each
#  of the protocols we want translated.
#
%filters = (
   "tcp" => '"tcp[13] & 2 != 0"',
   "udp" => '"udp"',
   "icmp"=> '"icmp"',
);
#
if ($date_len == 8) {
%files = (
   "tcp" => "/LOG/".$logger_location."/".$subdir."/tcp.".$snifdate.".gz",
   "udp" => "/LOG/".$logger_location."/".$subdir."/tcp.".$snifdate.".gz",
   "icmp"=> "/LOG/".$logger_location."/".$subdir."/tcp.".$snifdate.".gz",
);
} else {
%files = (
   "tcp" => "/LOG/".$logger_location."/".$subdir . "/day_tcp.gz",
   "udp" => "/LOG/".$logger_location."/".$subdir . "/day_udp.gz",
   "icmp"=> "/LOG/".$logger_location."/".$subdir . "/day_icmp.gz",
);
}
#  Loop through each of the protocols, read the zipped raw data file and
#  write out the required fields to the new data file.
#
foreach $protocol (keys %filters) {
   $newdata_file=">/tmp/". $logger_location ."_" .  $protocol.".$snifdate";
   open(NEWDATA, $newdata_file) or die("Cant open new datafile $!\n");
   $unix_cmd="gunzip -c $files{$protocol} | tcpdump -n -r - $filters{$protocol}";
   print LOGFILE "unix_cmd = $unix_cmd\n";
   open(LOGDATA, "$unix_cmd|") || die "Can't open data file: $!\n" ;
   while (<LOGDATA>){
       ($crap, $crap1, $junk3, $crap2) = split(/\s+/,$_);
       chop($crap2);
       ($time) = split(/\./,$crap);
       ($part1, $part2, $part3, $part4, $src_port) = split(/\./, $crap1);
       $src="$part1.$part2.$part3.$part4";
       ($part1, $part2, $part3, $part4, $dst_port) = split(/\./, $crap2);
       $dest="$part1.$part2.$part3.$part4";
       print NEWDATA "$outdate $time,$src,$src_port,$dest,$dst_port,$protocol\n";
   }
   close(LOGDATA);
   close(NEWDATA);
}
#
#  Copy the created Vicki files to machine lotus.nswc.navy.mil
#
foreach $protocol (keys %filters) {
   $newdata_file="/tmp/".$logger_location."_".$protocol.".".$snifdate;
   $newdest_file= "lotus:".$logger_location."/".$protocol.".".$snifdate;
   print LOGFILE "scp $newdata_file $newdest_file\n";
   system("scp $newdata_file $newdest_file") == 0
          or die("Unable to reach Lotus.");
   unlink $newdata_file
           or die ("Can't remove $newdata_file.");
}
